displayFile("<div class=\"file\">\n  <h2 id=\"src/util/delete.js\"> src/util/delete.js</h2>\n  <div id=\"stats\">\n    <div class=\"linecoverage\">\n      <span class=\"linecov low\">\n        [67.61%]\n      </span>\n      <span>96/142<span>\n      <span class=\"misses\">\n        46\n      </span>\n    </div>\n    <div class=\"branchcoverage\">\n      <span class=\"branchcov low\">\n        [89.66%]\n      </span>\n      <span>52/58</span>\n      <span class=\"misses\">\n        6\n      </span>\n    </div>\n  </div>\n  <table id=\"source\">\n    <thead>\n      <tr>\n        <th>Line</th>\n        <th>Hits</th>\n        <th>Source</th>\n      </tr>\n    </thead>\n    <tbody>\n      \n      \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">1</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">'use strict';</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">2</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">3</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">var _ = require('lodash');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">4</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">var async = require('async');</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">5</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">6</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">/**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">7</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">8</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * @param router</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">9</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * @returns {{submission: Function, form: Function}}</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">10</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">11</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">module.exports = function(router) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">12</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var hook = require('./hook')(router.formio);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">13</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">14</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">15</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Flag a submission as deleted. If given a subId, one submission will be flagged; if given a formId, then all the</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">16</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * submissions for that formId will be flagged.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">17</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">18</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId} subId</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">19</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The submission id to flag as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">20</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Array} forms</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">21</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   A list of form ids to flag all submissions as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">22</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Function} next</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">23</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The callback function to return the results.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">24</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">25</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var deleteSubmission = function(subId, forms, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">26</td>\n              <td class=\"hits\">72</td>\n              <td class=\"source\">    var debug = require('debug')('formio:delete:submission');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">27</td>\n              <td class=\"hits\">72</td>\n              <td class=\"source\">    var util = router.formio.util;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">28</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (!subId && !forms) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">29</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      debug('Skipping');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">30</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">31</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">32</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // Convert the forms to an array if only one was provided.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">33</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (forms && !(forms instanceof Array)) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">34</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      forms = [forms];</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">35</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">36</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">37</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // Build the query, using either the subId or forms array.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">38</td>\n              <td class=\"hits\">72</td>\n              <td class=\"source\">    var query = {deleted: {$eq: null}};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">39</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (subId) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">40</td>\n              <td class=\"hits\">48</td>\n              <td class=\"source\">      query._id = util.idToBson(subId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">41</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">42</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    else {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">43</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      forms = _(forms)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">44</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .map(util.idToBson)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">45</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .value();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">46</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">47</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      query.form = {$in: forms};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">48</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">49</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">50</td>\n              <td class=\"hits\">72</td>\n              <td class=\"source\">    debug('Deleting ' + (subId ? 'single submission' : 'multiple submissions'));</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">51</td>\n              <td class=\"hits\">72</td>\n              <td class=\"source\">    router.formio.resources.submission.model.find(query, function(err, submissions) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">52</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">53</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">54</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">55</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">56</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!submissions || submissions.length === 0) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">57</td>\n              <td class=\"hits\">18</td>\n              <td class=\"source\">        debug('No submissions found.');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">58</td>\n              <td class=\"hits\">18</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">59</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">60</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">61</td>\n              <td class=\"hits\">54</td>\n              <td class=\"source\">      async.eachSeries(submissions, function(submission, cb) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">62</td>\n              <td class=\"hits\">57</td>\n              <td class=\"source\">        submission.deleted = Date.now();</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">63</td>\n              <td class=\"hits\">57</td>\n              <td class=\"source\">        submission.markModified('deleted');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">64</td>\n              <td class=\"hits\">57</td>\n              <td class=\"source\">        submission.save(cb);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">65</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }, next);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">66</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">67</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">68</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">69</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">70</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Flag an Action as deleted. If given a actionId, one action will be flagged; if given a formId, or array of formIds,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">71</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * then all the Actions for that form, or forms, will be flagged.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">72</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">73</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId} actionId</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">74</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The Action id to flag as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">75</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId|Array} forms</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">76</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   A list of form ids to flag all Actions as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">77</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Function} next</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">78</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The callback function to return the results.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">79</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">80</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var deleteAction = function(actionId, forms, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">81</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    var debug = require('debug')('formio:delete:action');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">82</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    var util = router.formio.util;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">83</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (!actionId && !forms) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">84</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      debug('Skipping');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">85</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">86</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">87</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // Convert the forms to an array if only one was provided.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">88</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (forms && !(forms instanceof Array)) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">89</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      forms = [forms];</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">90</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">91</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">92</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    var query = {deleted: {$eq: null}};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">93</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (actionId) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">94</td>\n              <td class=\"hits\">7</td>\n              <td class=\"source\">      query._id = util.idToBson(actionId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">95</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">96</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    else {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">97</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      forms = _(forms)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">98</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .map(util.idToBson)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">99</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .value();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">100</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">101</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      query.form = {$in: forms};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">102</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">103</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">104</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    debug('Deleting ' + (actionId ? 'single action' : 'multiple actions'));</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">105</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">106</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">    router.formio.actions.model.find(query, function(err, actions) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">107</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">108</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">109</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">110</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">111</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!actions || actions.length === 0) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">112</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug('No actions found.');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">113</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">114</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">115</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">116</td>\n              <td class=\"hits\">31</td>\n              <td class=\"source\">      async.eachSeries(actions, function(action, cb) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">117</td>\n              <td class=\"hits\">33</td>\n              <td class=\"source\">        action.settings = action.settings || {};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">118</td>\n              <td class=\"hits\">33</td>\n              <td class=\"source\">        action.deleted = Date.now();</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">119</td>\n              <td class=\"hits\">33</td>\n              <td class=\"source\">        action.markModified('deleted');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">120</td>\n              <td class=\"hits\">33</td>\n              <td class=\"source\">        action.save(cb);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">121</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }, next);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">122</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">123</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">124</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">125</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">126</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Flag a form as deleted. If given a formId, one form will be flagged;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">127</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">128</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId} formId</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">129</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The form id to flag as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">130</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Function} next</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">131</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The callback function to return the results.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">132</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">133</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var deleteForm = function(formId, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">134</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">    var debug = require('debug')('formio:delete:form');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">135</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">    var util = router.formio.util;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">136</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (!formId) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">137</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      debug('Skipping');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">138</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">139</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">140</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">141</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">    var query = {_id: util.idToBson(formId), deleted: {$eq: null}};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">142</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">    debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">143</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">    router.formio.resources.form.model.findOne(query, function(err, form) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">144</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">145</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">146</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">147</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">148</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!form) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">149</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug('No form found with the _id: ' + formId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">150</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">151</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">152</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">153</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      form.deleted = Date.now();</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">154</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      form.markModified('deleted');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">155</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">      form.save(function(err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">156</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">157</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">158</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">159</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">160</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">161</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">        deleteAction(null, formId, function(err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">162</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">163</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">            debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">164</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">            return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">165</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">166</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">167</td>\n              <td class=\"hits\">24</td>\n              <td class=\"source\">          deleteSubmission(null, formId, next);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">168</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">169</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">170</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">171</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">172</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">173</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">174</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Delete all known references to access for the given role.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">175</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">176</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId} roleId</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">177</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The roleId to delete access for.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">178</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Object} req</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">179</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The express callback function.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">180</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Function} next</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">181</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The callback function to return the results.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">182</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">183</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var deleteRoleAccess = function(roleId, req, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">184</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var debug = require('debug')('formio:delete:roleaccess');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">185</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var util = router.formio.util;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">186</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (!roleId) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">187</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      debug('Skipping');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">188</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">189</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">190</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">191</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // Convert the roldId to a string for comparison.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">192</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    roleId = util.idToString(roleId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">193</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">194</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // The access types to check.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">195</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var accessType = ['access', 'submissionAccess'];</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">196</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">197</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // The formIds to check.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">198</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var formIds = null;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">199</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">200</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">201</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     * Remove the roleId from the forms' access types.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">202</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">203</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     * @param {Function} cb</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">204</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     *   The callback function to invoke after the role has been removed.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">205</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">206</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var removeFromForm = function(cb) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">207</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Build the or query on accessTypes.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">208</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      var or = [];</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">209</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      accessType.forEach(function(access) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">210</td>\n              <td class=\"hits\">6</td>\n              <td class=\"source\">        var temp = {};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">211</td>\n              <td class=\"hits\">6</td>\n              <td class=\"source\">        var key = access + '.roles';</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">212</td>\n              <td class=\"hits\">6</td>\n              <td class=\"source\">        temp[key] = util.idToBson(roleId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">213</td>\n              <td class=\"hits\">6</td>\n              <td class=\"source\">        or.push(temp);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">214</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">215</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">216</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Build the search query, and allow anyone to hook it.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">217</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      var query = {_id: {$in: _.map(formIds, util.idToBson)}, $or: or};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">218</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      query = hook.alter('formQuery', query, req);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">219</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">220</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">221</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      router.formio.resources.form.model.find(query).snapshot(true).exec(function(err, forms) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">222</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">223</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">224</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          return cb(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">225</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">226</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (!forms || forms.length === 0) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">227</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          return cb();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">228</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">229</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">230</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        // Iterate each form and remove the role.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">231</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">        debug('Found ' + forms.length + ' forms to modify.');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">232</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">        async.eachSeries(forms, function(form, done) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">233</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          // Iterate each access type to remove the role.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">234</td>\n              <td class=\"hits\">40</td>\n              <td class=\"source\">          accessType.forEach(function(access) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">235</td>\n              <td class=\"hits\">80</td>\n              <td class=\"source\">            var temp = form.toObject()[access] || <i class=\"cond-miss\">[]</i>;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">236</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">237</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">            // Iterate the roles for each permission type, and remove the given roleId.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">238</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">            for (var b = 0; b < temp.length; b++) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">239</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">              // Convert the ObjectIds to strings for comparison.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">240</td>\n              <td class=\"hits\">100</td>\n              <td class=\"source\">              temp[b].roles = _.map((temp[b].roles || <i class=\"cond-miss\">[]</i>), util.idToString);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">241</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">242</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">              // Remove the given roleId if it was defined in the access.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">243</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">              if (temp[b].roles.indexOf(roleId) !== -1) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">244</td>\n              <td class=\"hits\">43</td>\n              <td class=\"source\">                _.pull(temp[b].roles, roleId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">245</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">              }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">246</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">247</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">              // Convert the role ids back to bson strings for storage.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">248</td>\n              <td class=\"hits\">100</td>\n              <td class=\"source\">              temp[b].roles = _.map((temp[b].roles || <i class=\"cond-miss\">[]</i>), util.idToBson);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">249</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">            }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">250</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">251</td>\n              <td class=\"hits\">80</td>\n              <td class=\"source\">            form.set(access, temp);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">252</td>\n              <td class=\"hits\">80</td>\n              <td class=\"source\">            form.markModified(access);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">253</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">254</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">255</td>\n              <td class=\"hits\">40</td>\n              <td class=\"source\">          form.save(done);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">256</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }, cb);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">257</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">258</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">259</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">260</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">261</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     * Remove the roleId from the submissions for the given formIds.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">262</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">263</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     * @param {Function} cb</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">264</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     *   The callback function to invoke after the roles have been removed.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">265</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">     */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">266</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var removeFromSubmissions = function(cb) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">267</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Find all submissions that contain the role in its roles.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">268</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      var query = {form: {$in: _.map(formIds, util.idToBson)}, deleted: {$eq: null}, roles: util.idToBson(roleId)};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">269</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">270</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      router.formio.resources.submission.model.find(query).snapshot(true).exec(function(err, submissions) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">271</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">272</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">273</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          return cb(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">274</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">275</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (!submissions || submissions.length === 0) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">276</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">          return cb();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">277</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">278</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">279</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        // Iterate each submission to filter the roles.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">280</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        async.eachSeries(submissions, function(submission, done) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">281</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          var temp = _.map((<i class=\"cond-miss\">submission.toObject().roles</i> || <i class=\"cond-miss\">[]</i>), util.idToString);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">282</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">283</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          // Omit the given role from all submissions.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">284</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          if (<i class=\"cond-miss\">temp.indexOf(roleId) !== -1</i>) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">285</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">            _.pull(temp, roleId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">286</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">287</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">288</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">          // Convert all the roles back to bson strings for storage.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">289</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          temp = _.map(temp, util.idToBson);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">290</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">291</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          submission.set('roles', temp);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">292</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          submission.markModified('roles');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">293</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          submission.save(done);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">294</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }, cb);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">295</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">296</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">297</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">298</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    // Build the search query and allow anyone to hook it.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">299</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var query = {deleted: {$eq: null}};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">300</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    query = hook.alter('formQuery', query, req);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">301</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">302</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    router.formio.resources.form.model.find(query).select('_id').snapshot(true).exec(function(err, ids) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">303</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">304</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">305</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">306</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">307</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!ids) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">308</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug('No form ids found.');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">309</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">310</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">311</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">312</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // update the list of formIds</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">313</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      formIds = _(ids)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">314</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .pluck('_id')</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">315</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .map(util.idToString)</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">316</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        .value();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">317</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">318</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      async.series([</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">319</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        removeFromForm,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">320</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        removeFromSubmissions</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">321</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      ], next);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">322</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">323</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">324</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">325</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">326</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Flag a Role as deleted. If given a roleId, one Role will be flagged;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">327</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">328</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {String|ObjectId} roleId</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">329</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The Role id to flag as deleted.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">330</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Object} req</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">331</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The express request object.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">332</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * @param {Function} next</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">333</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   *   The callback function to return the results.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">334</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">335</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  var deleteRole = function(roleId, req, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">336</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var debug = require('debug')('formio:delete:role');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">337</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var util = router.formio.util;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">338</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    if (!roleId) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">339</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      debug('Skipping');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">340</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">      return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">341</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">342</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">343</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    var query = {_id: util.idToBson(roleId), deleted: {$eq: null}};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">344</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">345</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">    router.formio.resources.role.model.findOne(query, function(err, role) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">346</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">347</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">348</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">349</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">350</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!role) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">351</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        debug('No role found with _id: ' + roleId);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">352</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">353</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">354</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">355</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      role.deleted = Date.now();</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">356</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      role.markModified('deleted');</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">357</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">      role.save(function(err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">358</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        if (err) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">359</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          debug(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">360</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">          return next(err);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">361</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">362</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">363</td>\n              <td class=\"hits\">3</td>\n              <td class=\"source\">        deleteRoleAccess(roleId, req, next);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">364</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">365</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    });</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">366</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">367</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">368</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  /**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">369</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   * Expose the internal functionality for hiding 'deleted' entities.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">370</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">   */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">371</td>\n              <td class=\"hits\">4</td>\n              <td class=\"source\">  return {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">372</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    submission: deleteSubmission,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">373</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    form: deleteForm,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">374</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    action: deleteAction,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">375</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    role: deleteRole</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">376</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">377</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">378</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n    </tbody>\n  </table>\n</div>");